<!-- balance 余额明细 -->
<template>
    <div>
<!--        <div class="mb20">-->
<!--            &lt;!&ndash; <el-label>-->
<!--                当前商户类型: {{this.getRank()}}-->
<!--            </el-label> &ndash;&gt;-->
<!--            <br/>-->
<!--            <br/>-->
<!--             <span> 个人商户 </span> <el-radio v-model="radio" label="1">2000</el-radio>-->
<!--             <span> 商户号 </span>  <el-radio v-model="radio" label="2">1000</el-radio> <br> <br>-->
<!--             &lt;!&ndash; <span> 特殊个人商铺 </span> <el-radio v-model="radio" label="3">2000</el-radio>-->
<!--             <span> 特殊商业 </span> <el-radio v-model="radio" label="4">1000</el-radio> &ndash;&gt;-->
<!--            <br/>-->
<!--            <br/>-->
<!--            <br/>-->
<!--            <el-button class="ml10" icon="el-icon-search" size="small" type="primary" @click="m_pay">交付押金</el-button>-->
<!--        </div>-->

<!--        <h3>交易次数</h3>-->
<!--        <el-table-->
<!--                :data="tableData"-->
<!--                height="250"-->
<!--                style="width: 100%">-->
<!--            <el-table-column-->
<!--                    prop="original_total"-->
<!--                    label="金额"-->
<!--                    width="180">-->
<!--            </el-table-column>-->
<!--            <el-table-column-->
<!--                    prop="created_at"-->
<!--                    label="日期"-->
<!--                    width="180">-->
<!--            </el-table-column>-->
<!--        </el-table>-->

        <!--        <h3>Refunds</h3>-->
        <!--        <el-table-->
        <!--                :data="refundsData"-->
        <!--                height="250"-->
        <!--                style="width: 100%">-->
        <!--            <el-table-column-->
        <!--                    prop="amount"-->
        <!--                    label="Amount"-->
        <!--                    width="180">-->
        <!--            </el-table-column>-->
        <!--            <el-table-column-->
        <!--                    prop="bank_name"-->
        <!--                    label="Bank Name"-->
        <!--                    width="180">-->
        <!--            </el-table-column>-->
        <!--            <el-table-column-->
        <!--                    prop="bank_account_no"-->
        <!--                    label="Bank Account"-->
        <!--                    width="180">-->
        <!--            </el-table-column>-->
        <!--            <el-table-column-->
        <!--                    prop="bank_account_holder_name"-->
        <!--                    label="Bank Account Holder"-->
        <!--                    width="180">-->
        <!--            </el-table-column>-->
        <!--        </el-table>-->

<!--        押金余额: {{this.totalDeposit - this.totalRefund}}-->
       
        <br>
        <br>
        <br>
        <div class="row">
            <div class="col-md-12">
                <p class="pCUM">当前商户类型: {{this.getRank()}}</p>
            </div>
            <div class="colM12C col-md-12">
                    <h2 class="UnP">未付定金</h2>
                    <div v-for="(item,index) in optionLists" :key="index">
                        <el-radio v-model="radio" :label="item.rank_id">{{item.amount}}</el-radio> &nbsp;
                    </div>
                    <!-- <el-radio v-model="radio" label="1">2000</el-radio>
                    <el-radio v-model="radio" label="2">1000</el-radio> -->
            </div>
        </div>
        <br>
        <br>
         <div class="row">
            <div class="col-md-12">
                <button class="customBtnUA btn btn-default" @click="m_pay()">交付押金</button>
            </div>
        </div>
        <br>
        <br>
        <br>
        <br>
        <br>
        <div class="row">
            <div class="colMd12T el-col-md-12">
                <p class="tT">订单号</p>
                <p class="dB">押金余额: {{this.totalDeposit}}</p>
            </div>
            <div class="customSetWidthElCol el-col-md-12" style="width: 100%">
                <el-table
                        :data="tableData"
                        height="250"
                        style="width: 100%">
                    <el-table-column
                            prop="order_no"
                            label="订单号码"
                            width="180">
                    </el-table-column>
                    <el-table-column
                            prop="created_at"
                            label="日期"
                            width="180">
                    </el-table-column>
                    <el-table-column
                            prop="original_total"
                            label="金额"
                            width="180">
                    </el-table-column>
                    <el-table-column
                            label="状态"
                            width="120">
                        <template slot-scope="scope">
                            <button class="statusBtn">已付费</button>
                        </template>
                    </el-table-column>
                    <el-table-column
                            label="行动"
                            width="300">
                        <template slot-scope="scope">
                            <div v-if="scope.row.status == 5"> 退款中 </div>
                            <div >
                                <button v-if="scope.row.status == 4" @click="showDetail(scope.row)" class="statusBtn" style="margin-left: 5px">
                                    已退款
                                </button>
                            </div>
                            <button v-if="scope.row.status == 1" class="statusBtn" style="margin-left: 5px"
                                    @click="refund(scope.row.original_total, scope.row.id)">退款
                            </button>
                        </template>
                    </el-table-column>
                </el-table>
            </div>
        </div>

        <el-dialog title="申请退款" :visible.sync="dialogFormVisible">
            <el-form :model="withdrawForm">
                <!--                <el-form-item label="提款金额" label-width="80px" prop="amount">-->
                <!--                    <el-input clearable v-model="withdrawForm.amount" auto-complete="off"></el-input>-->
                <!--                </el-form-item>-->
                <el-form-item label="所属银行" label-width="80px" prop="bank_name">
                    <el-input clearable v-model="withdrawForm.bank_name" auto-complete="off"></el-input>
                </el-form-item>
                <!--                <el-form-item label="银行户口" label-width="80px" prop="bank_no">-->
                <!--                    <el-input clearable v-model="withdrawForm.bank_no" auto-complete="off"></el-input>-->
                <!--                </el-form-item>-->
                <el-form-item label="银行号码 " label-width="80px" prop="bank_account_no">
                    <el-input clearable v-model="withdrawForm.bank_account_no" auto-complete="off"></el-input>
                </el-form-item>
                <el-form-item label="银行持有人姓名" label-width="80px" prop="bank_holder">
                    <el-input clearable v-model="withdrawForm.bank_holder" auto-complete="off"></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="dialogFormVisible = false">关</el-button>
                <el-button type="primary" @click="confirmWithdraw()">确认</el-button>
            </span>
        </el-dialog>

        <el-dialog
                title="退款明细"
                :visible.sync="dialogVisible"
                width="30%">
            <div class="demo-image__preview">
                <el-image
                        style="width: 100px; height: 100px"
                        :src="this.refundData.img_url"
                >
                </el-image>
                <br/>
                <span> 退款额度 : {{refundData.amount}} </span> <br>
                <span> 所属银行 : {{refundData.bank_name}} </span> <br>
                <span> 银行号码 : {{refundData.bank_account_no}} </span>
                <span> 银行持有人姓名 : {{refundData.bank_account_holder_name}} </span>
            </div>
            <span slot="footer" class="dialog-footer">
                <el-button @click="dialogVisible = false">关</el-button>
            </span>
        </el-dialog>


    </div>

</template>


<script>
    import search from '@/assets/icon/icon/search.png'
    import delete2x from '@/assets/icon/icon/delete2x.png'
    import detail2x from '@/assets/icon/icon/details2x.png'
    import * as api from '@/api'
    import axios from '../../components/downloadFile/axios'
    import detail from "../order/detail";

    export default {
        name: 'pay',
        data() {
            return {
                dialogVisible: false,
                formLabelWidth: '120px',
                dialogFormVisible: false,
                withdrawForm: {
                    order_id: '',
                    amount: '',
                    img_url: '',
                    bank_holder: '',
                    bank_account_no: '',
                    // bank_no: '',
                    bank_name: '',
                },
                editImage: detail2x,
                deleteImage: delete2x,
                search: search,
                radio: 0,
                radio2: 0,
                search_data: {
                    search: '',
                    type: '',
                    start_end: []
                },
                formData: {
                    amount: '',
                    img_url: '',
                },
                m_show: false,
                m_showForm: false,
                image: '',
                id: '',
                tableData: [],
                refundsData: [],
                totalRefund: 0,
                totalDeposit: 0,
                userInfo: {},
                refundData: {},
                optionLists: {},
            }
        },
        mounted() {
            console.log('this is upgrade account page');
            let rank = JSON.parse(sessionStorage.userInfo).seller.rank_id;
            api.seller_topup_lists({
                    rank_id: rank
            }).then((response) => {
                this.optionLists = response.data;
            });
        },
        created() {
            this.init();
            this.userInfo = sessionStorage.userInfo && JSON.parse(sessionStorage.userInfo) || {}
        },
        methods: {
            showDetail(data){
                this.dialogVisible = true;
                console.log(data);
                this.refundData = data.seller_refund_request;
                console.log(this.refundData.img_url);
            },
            //初始化方法
            confirmWithdraw() {
                this.dialogFormVisible = false;
                console.log(this.withdrawForm);
                this.withdrawForm.user_id = this.userInfo.id;
                api.deposit_withdraw_request(this.withdrawForm).then(res => {
                    console.log(res);
                    if (res.code == 0) {
                        this.m_success('Withdraw request made...!')
                        this.init();
                    }
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            init() {
                this.userInfo = sessionStorage.userInfo && JSON.parse(sessionStorage.userInfo) || {}
                this.getData();
                this.getRefunds();
                if (this.$route.query.out_trade_no) {
                    this.paymentSuccess();
                    let that = this;
                }
            },
            paymentSuccess() {
                let that = this;
                api.payment_success({
                    'user_id': this.userInfo.id,
                    'order_id': sessionStorage.order_id,
                    'rank_id': sessionStorage.new_rank
                }).then(res => {
                    that.userInfo['seller']['rank_id'] = sessionStorage.new_rank;
                    sessionStorage.userInfo = JSON.stringify(that.userInfo);
                    sessionStorage.order_id = null;
                    sessionStorage.new_rank = null;
                    setTimeout(function () {
                        window.location = '#/finance/pay';
                    }, 2000);
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            refund(total, id) {
                this.withdrawForm.amount = total;
                this.withdrawForm.order_id = id;
                this.dialogFormVisible = true;
            },
            calculateFinals() {
                let totalRefunds = 0;
                this.refundsData.map(function (res) {
                    if(res.status == 1)
                    totalRefunds += res.amount;
                });
                this.totalRefund = totalRefunds;

                let totalDeposit = 0;
                this.tableData.map(function (res) {
                    if (res.status == 1) {
                        console.log(res.original_total);
                        totalDeposit += res.original_total;
                    }
                });
                this.totalDeposit = totalDeposit;
            },
            getData() {
                api.seller_transactions({
                    'user_id': this.userInfo.id
                }).then(res => {
                    this.tableData = res.data
                    this.calculateFinals()
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            getRefunds() {
                api.seller_transactions_refunds({
                    'user_id': this.userInfo.id
                }).then(res => {
                    this.refundsData = res.data;
                    this.calculateFinals();
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            getRank() {
                let rank = this.userInfo.seller.rank_id;
                if (rank == 0) {
                    return '未付押金';
                }
                if (rank == 1) {
                    return '个人商户';
                }
                if (rank == 2) {
                    return '商户号';
                }

            },
            getAmt(cb) {
                let currentRank = JSON.parse(sessionStorage.userInfo).seller.rank_id;
                let upgradeRankTo = this.radio;
                if (currentRank == 0) {
                    if (upgradeRankTo == 1) {
                        cb({
                            amount: 2000,
                            message: '',
                            rank: upgradeRankTo
                        })
                    }
                    if (upgradeRankTo == 2) {
                        cb({
                            amount: 1000,
                            message: '',
                            rank: upgradeRankTo
                        })
                    }
                }
            },
            getAmount(cb) {
                let rank = JSON.parse(sessionStorage.userInfo).seller.rank_id;
                let upgradeRank = this.radio;
                api.seller_topup_lists({
                    rank_id: rank
                }).then((response) => {
                    if (response.data.length > 0) {
                        response.data.forEach(element => {
                           if (element.rank_id == upgradeRank) {
                               cb(element);
                           }
                        });
                    }
                });
                return {
                    amount: 0,
                    message: 'something is fishy'
                };
                // if (rank == 0) {
                //     if (upgradeRank == 1) {
                //         cb({
                //             amount: 2000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 2) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 3) {
                //         cb({
                //             amount: 2000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 4) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                // }
                // if (rank == 1) {
                //     if (upgradeRank == 2) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 3) {
                //         cb({
                //             amount: 2000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 4) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                // }
                // if (rank == 2) {
                //     if (upgradeRank == 1) {
                //         cb({
                //             amount: -1,
                //             message: 'downgrade',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 2) {
                //         cb({
                //             amount: 0,
                //             message: '已达相同等级',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 3) {
                //         cb({
                //             amount: 2000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 4) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                // }

                // if (rank == 2) {
                //     if (upgradeRank == 1) {
                //         cb({
                //             amount: -1,
                //             message: 'downgrade',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 2) {
                //         cb({
                //             amount: 0,
                //             message: '已达相同等级',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 3) {
                //         cb({
                //             amount: 2000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 4) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                // }
                // if (rank == 3) {
                //     if (upgradeRank == 1) {
                //         cb({
                //             amount: 2000,
                //             message: 'downgrade',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 2) {
                //         cb({
                //             amount: 1000,
                //             message: '已达相同等级',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 3) {
                //         cb({
                //             amount: 0,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                //     if (upgradeRank == 4) {
                //         cb({
                //             amount: 1000,
                //             message: '',
                //             rank: upgradeRank
                //         });
                //     }
                // }
                // return {
                //     amount: 0,
                //     message: 'something is fishy'
                // }
            },
            m_pay() {
                console.log('m_pay');
                let that = this;
                this.getAmount(function (am) {
                    console.log(am);
                    if (am.amount < 1) {
                        if (am.amount == -1) {
                            sessionStorage.new_rank = am.rank;
                            console.log('new rank is' + sessionStorage.new_rank);
                            api.downgrade({
                                'user_id': that.userInfo.id,
                                'rank_id': sessionStorage.new_rank
                            }).then(res => {
                                console.log(res);
                                that.userInfo['seller']['rank_id'] = sessionStorage.new_rank;
                                sessionStorage.userInfo = JSON.stringify(that.userInfo)
                                sessionStorage.order_id = null;
                                sessionStorage.new_rank = null;
                                setTimeout(function () {
                                    window.location = '#/finance/pay';
                                }, 2000);

                                // this.tableData = res.data
                                // this.calculateFinals()
                            }).finally((err) => {
                                console.log(err);
                                this.m_tableLoading = false
                            })
                        } else {
                            alert(am.message);
                        }
                    } else {
                        api.generate_seller_order({
                            'user_id': that.userInfo.id,
                            'amount': am.amount
                        }).then(res => {
                            if (res.code == 0) {
                                sessionStorage.order_id = res.data.id;
                                let ob = {
                                    order_id: res.data.id,
                                    user_id: that.userInfo.id,
                                    rank_id: am.rank
                                };
                                let config = {
                                    headers: {
                                        'Authorization': `Bearer ${sessionStorage.token}`,
                                    }
                                };
                                api.pay_order_seller(ob, config).then(res => {
                                    setTimeout(() => {
                                        sessionStorage.new_rank = am.rank;
                                        window.location.assign(res.data)
                                    }, 1000)
                                    return res
                                }).finally((err) => {
                                })
                            }

                        }).finally((err) => {
                        })
                    }
                });
            }
        },
    }

</script>
<style lang='scss' scoped>
    .el-table {
        border: 1px solid #efefef;
        padding: 10px;
    }

    .el-table th {
        border-bottom: 1px solid #efefef;
    }

    .el-table th:nth-last-child() {
        border-bottom: 0px;
    }

    .el-table td, .el-table th.is-leaf:nth-last-child() {
        border-bottom: 0px;
    }

    .customSetWidthElCol {
        width: 57%;
    }

    .editImage {
        cursor: pointer;
        width: 15px;
        margin-right: 10px;
    }

    .delImage {
        cursor: pointer;
        width: 15px;
    }

    .statusBtn {
        background: #C9E4FC;
        border-color: #3F9CF6;
        border-radius: 6px;
        padding: 7px 20px;
        color: #3F9CF6;
    }

    .dB {
        font-size: 14px;
        color: gray;
        font-weight: bold;
    }

    .tT {
        font-weight: bold;
        font-size: 14px;
        color: gray;
        flex: 1;
    }

    .colMd12T {
        display: flex;
        width: 57%;
    }

    .searchPng {
        position: absolute;
        margin-top: 10px;
        padding-left: 6px;
    }

    .customBtnSearch {
        height: 39px;
        width: 120px;
        color: #fff;
        background: #3F9CF6;
        border: 0px;
        cursor: pointer;
    }

    .customBtnExport {
        cursor: pointer;
        margin-left: 15px;
        height: 39px;
        width: 120px;
        color: #fff;
        background: #F76C6C;
        border: 0px;
    }

    .customInput {
        padding-left: 30px;
        height: 35px;
        width: 30%;
    }

    .customBtnUA {
        cursor: pointer;
        font-weight: bold;
        background: #3F9CF6;
        color: #fff;
        border-radius: 6px;
        width: 100%;
        height: 40px;
        border: 0px;
        border-color: unset;
    }

    .colM12C {
        display: flex;
        align-items: center;
    }

    .pCUM {
        font-size: 10px;
        margin-bottom: 10px;
    }

    .UnP {
        padding-right: 50px;
    }

    .el-radio__label {
        font-weight: bold !important;
        font-size: 17px !important;
        padding-left: 10px;
    }
</style>
